/* LCD_4.c V1.0
 * LCD Functions Developed by dracek
 * 12.2.2015
 */

#include "lcd_4.h"






void lcd_port(char a)
{
    if(a & 1) D4 = 1; else D4 = 0;
    if(a & 2) D5 = 1; else D5 = 0;
    if(a & 4) D6 = 1; else D6 = 0;
    if(a & 8) D7 = 1; else D7 = 0;
}

void lcd_cmd(unsigned char cmd)
{
    EN = 1;
    lcd_port(cmd);
    __delay_us(1);
    EN = 0;
    __delay_us(1);
}


void lcd_clear()
{
    //smazat lcd
    lcd_cmd(0b0000);
    lcd_cmd(0b0001);
    __delay_ms(2);
}

void lcd_init()
{
    __delay_ms(20); //cekat 20ms, pokud by k inicializaci doslo hned po zapnuti

    RS = 0;
    RW = 0;

    //8 bit komunikace
    lcd_cmd(0b0011);
    __delay_ms(2);

    //8 bit komunikace
    lcd_cmd(0b0011);
    __delay_ms(2);

    //8 bit komunikace
    lcd_cmd(0b0011);
    __delay_ms(2);

    //4 bit komunikace
    lcd_cmd(0b0010);
    __delay_us(40);


    //4 bit komunikace, 2 radky
    lcd_cmd(0b0010);
    lcd_cmd(0b1000);
    __delay_us(40);

    //zapnout lcd, vypnout kurzor, vypnout blikani
    lcd_cmd(0b0000);
    lcd_cmd(0b1100);
    __delay_us(40);

    //smer pohybu vys
    lcd_cmd(0b0000);
    lcd_cmd(0b0110);
    __delay_us(40);

    //smazat lcd
    lcd_clear();
}


void lcd_zapis(const char *str)
{
    unsigned char x = 0;
    while(str[x]!=0) {
        RS = 1;

        lcd_cmd((str[x] & 0xF0) >> 4);
        lcd_cmd((str[x] & 0x0F));
        __delay_us(40);

        RS = 0;

        x++;
    }
}

void lcd_move(char row, char col)
{
    char x;
    switch(row)
    {
        case 1:row=0x00;break;
        case 2:row=0x40;break;
    }

    x = (0b10000000 | row | col);

    lcd_cmd((x & 0xF0) >> 4);
    lcd_cmd((x & 0x0F));
    __delay_us(40);
}