/*
 * File:   main.c
 * Author: dracek
 *
 * Created on 27. duben 2014, 9:27
 */

#define _XTAL_FREQ 4000000  // 4MHz

#include <htc.h>
#include <stdlib.h>

#include "lcd_4.h"

#pragma config FOSC = INTOSCIO
#pragma config PWRTE = ON
#pragma config WDTE = OFF
#pragma config MCLRE = OFF
#pragma config BOREN = OFF
#pragma config LVP = OFF





unsigned char   cislo = 200;
char buf[4];

unsigned short  konstanta = 8192;

short long cas_temp = 1000000;



void interrupt tc_int(void) {
    if (TMR0IF) {
        TMR0IF = 0;

        cas_temp = cas_temp - konstanta;

        if (cas_temp <= 0) {

            cas_temp = cas_temp + 1000000;
        }

    }
    return;
}


void main() {

    CMCON = 0b00000111;
    OPTION_REG = 0b10000100;
    INTCON = 0b11100000;
    PIE1 = 0b00000000;
    T1CON = 0b00000000;

    TRISA = 0b00000000;
    TRISB = 0b00000000;

    PORTA = 0b00000000;
    PORTB = 0b00000000;


lcd_init();

    while(1) {
        cislo++;

      itoa(buf, cislo, 10);

      lcd_zapis("Cislo: ");

      if (cislo < 10) {
	lcd_zapis("00");
      }
      else if(cislo < 100) {
	 lcd_zapis("0");
      }

      lcd_zapis(buf);


      lcd_move(2,0);



      itoa(buf, 255-cislo, 10);

      lcd_zapis("Cislo: ");

      if (255-cislo < 10) {
	lcd_zapis("00");
      }
      else if(255-cislo < 100) {
	 lcd_zapis("0");
      }

      lcd_zapis(buf);

      __delay_ms(100);

      lcd_clear();


    }

}